//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  OrangeRed
#property indicator_color2  DeepSkyBlue
#property indicator_color3  LimeGreen
#property indicator_width1  2

extern int    DMIP_period1 = 5;
extern int    DMIP_period2 = 8;
extern int    DMIP_period3 = 14;
extern double LevelUp      = 50;
extern double LevelDown    = 10;

double buff1[];
double buff2[];
double buff3[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buff1);
   SetIndexBuffer(1,buff2);
   SetIndexBuffer(2,buff3);
      SetLevelValue(0,LevelUp);
      SetLevelValue(1,LevelDown);
   return(0);
}
int start()
{
   int i,countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);

   for(i=limit; i>=0; i--)
   {
      double adx  = 0;
      double adxr = 0;
      double dip  = 0;
      double dim  = 0;
         iWilders(DMIP_period1,adx,adxr,dip,dim,i,0); buff1[i] = dip;
         iWilders(DMIP_period2,adx,adxr,dip,dim,i,1); buff2[i] = dip;
         iWilders(DMIP_period3,adx,adxr,dip,dim,i,2); buff3[i] = dip;
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workADX[][21];
#define _DIp        0
#define _DIm        1
#define _ADX        2
#define _ADXR       3
#define _averageDIp 4
#define _averageDIm 5
#define _averageTR  6

void iWilders(int DMI.Length, double &tADX, double &tADXR, double &tDIp, double &tDIm, int i, int instanceNo)
{
   if (ArrayRange(workADX,0)!=Bars) ArrayResize(workADX,Bars); instanceNo *= 7; int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   double sf = (DMI.Length-1.0)/DMI.Length;

         double currTR  = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
         double DeltaHi = High[i] - High[i+1];
	      double DeltaLo = Low[i+1] - Low[i];
         double plusDM  = 0.00;
         double minusDM = 0.00;
         
            if ((DeltaHi > DeltaLo) && (DeltaHi > 0)) plusDM  = DeltaHi;
            if ((DeltaLo > DeltaHi) && (DeltaLo > 0)) minusDM = DeltaLo;      
         
         //
         //
         //
         //
         //
         
            workADX[r][instanceNo+_averageDIp] = sf*workADX[r-1][instanceNo+_averageDIp] + plusDM;
            workADX[r][instanceNo+_averageDIm] = sf*workADX[r-1][instanceNo+_averageDIm] + minusDM;
            workADX[r][instanceNo+_averageTR]  = sf*workADX[r-1][instanceNo+_averageTR]  + currTR;

         //
         //
         //
         //
         //
                  
            workADX[r][instanceNo+_DIp] = 0.00;                   
            workADX[r][instanceNo+_DIm] = 0.00;                   
            if (workADX[r][instanceNo+_averageTR] > 0)
               {              
                  workADX[r][instanceNo+_DIp] = 100.00 * workADX[r][instanceNo+_averageDIp]/workADX[r][instanceNo+_averageTR];
                  workADX[r][instanceNo+_DIm] = 100.00 * workADX[r][instanceNo+_averageDIm]/workADX[r][instanceNo+_averageTR];
               }            
               double DX;
               if((workADX[r][instanceNo+_DIp] + workADX[r][instanceNo+_DIm])>0) 
                    DX = 100*MathAbs(workADX[r][instanceNo+_DIp] - workADX[r][instanceNo+_DIm])/(workADX[r][instanceNo+_DIp] + workADX[r][instanceNo+_DIm]); 
               else DX = 0.00;
               workADX[r][instanceNo+_ADX]       = sf*workADX[r-1][instanceNo+_ADX] + DX/DMI.Length; 
               workADX[r][instanceNo+_ADXR]      = 0.5*(workADX[r][instanceNo+_ADX] + workADX[r-DMI.Length][instanceNo+_ADX]);
   //
   //
   //
   //
   //
   
   tADX  = workADX[r][instanceNo+_ADX];
   tADXR = workADX[r][instanceNo+_ADXR];
   tDIp  = workADX[r][instanceNo+_DIp];
   tDIm  = workADX[r][instanceNo+_DIm];
}